//+------------------------------------------------------------------+
//|                                                 VisualTester.mq5 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_plots   3
//--- plot Label1
#property indicator_label1  "Label1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrGreen
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Label2
#property indicator_label2  "Label2"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot Label3
#property indicator_label3  "Label3"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrBlue
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1

#include <MT4Orders.mqh>
#include <fxsaber\Virtual\Virtual.mqh>
#define OnTick ExpOnTick
#define OnInit ExpOnInit
#define CopyBuffer ExpCopyBuffer
#include <..\Experts\My\Tester.mq5>
#undef OnTick
#undef OnInit
#undef CopyBuffer

//--- indicator buffers
double         Label1Buffer[];
double         Label2Buffer[];
double         Label3Buffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,Label1Buffer,INDICATOR_DATA);
   SetIndexBuffer(1,Label2Buffer,INDICATOR_DATA);
   SetIndexBuffer(2,Label3Buffer,INDICATOR_DATA);
   ArraySetAsSeries(Label1Buffer,1);
   ArraySetAsSeries(Label2Buffer,1);
   ArraySetAsSeries(Label3Buffer,1);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0.);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0.);
   
   EventSetMillisecondTimer(100);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
   ArrayInitialize(Label1Buffer,0.); ArrayInitialize(Label2Buffer,0.); ArrayInitialize(Label3Buffer,0.);
   
   fn0();//
   
   ChartRedraw();
   EventKillTimer();   
  }
//+------------------------------------------------------------------+

void fn0()
  {
   int total=9000;
   double   data[]; if(CopyClose(_Symbol,_Period,0,total,data)!=total) {Print("CopyClose Error"); return;}
   datetime time[]; CopyTime (_Symbol,_Period,0,total,time);
   MqlTick Ticks[]; ArrayResize(Ticks,total); 
   for(int i=0;i<total;i++)
     {Ticks[i].ask=data[i]+0.0001;
      Ticks[i].bid=data[i];
      Ticks[i].flags=TICK_FLAG_BID|TICK_FLAG_ASK;
      Ticks[i].time=time[i];
      Ticks[i].time_msc=time[i]*1000;
     }
   
   VIRTUAL::SelectByHandle(VIRTUAL::Create());
   ExpOnInit();
   for(int i=0;i<total;i++)
     {CopyBuffer(h,0,total-1-i,1,ma);
      VIRTUAL::NewTick(Ticks[i],ExpOnTick);
      Label1Buffer[total-1-i]=AccountEquity();
     }
   VIRTUAL::Delete();
   
   return;
  }
  
int ExpCopyBuffer(int indicator_handle, int buffer_num, int start_pos, int count, double& buffer[])
  {
   return ArraySize(buffer);
  }